import java.awt.*;

/** This function does something (ie the simulated work of the
 * loop). */
public class FunctionF extends Function {
    /** Channels. */
    private Channel<Integer> in,out;

    public FunctionF(Channel<Integer> in,Channel<Integer> out) {
        this.in = in;
        this.out = out;
        label = "F";
    }

    public void setPoints() {
        in.dx = x+w/2;
        in.dy = y+h;
        out.x = x+w/2;
        out.y = y;
    }

    protected void canFire() {
        in.mustReceive();
        out.mustSend();
    }

    protected void fire() {
        Integer i = in.receive();
        // our work here is to multiple it by 2
        i = new Integer(i.intValue()*2);
        if (Circuit.debug)
            System.out.println("F: "+i.intValue());
        out.send(i);
    }
}
