/**
 * PAUL HUSSMAN
 * 260224172
 * COMP 409 ASSIGNMENT 4
 * FALL 2010
 */

import java.awt.*;
import java.awt.geom.*;

/** A function to add its two inputs. */
public class FunctionPlus extends Function {
    /** Channels. */
    private Channel<Integer> out,in1,in2;

    public FunctionPlus(Channel<Integer> in1,Channel<Integer> in2,Channel<Integer> out) {
        this.in1 = in1;
        this.in2 = in2;
        this.out = out;
        label    = "+";
    }

    public void setPoints() {
        in1.dy = y+h/4;
        in1.dx = x;
        in2.dy = y+h/2+h/4;
        in2.dx = x;
        out.x  = x+w;
        out.y  = y+h/2;
    }

    protected void canFire() {
        out.mustSend();
        in1.mustReceive();
        in2.mustReceive();
    }

    protected void fire() {
        Integer i1 = in1.receive();
        Integer i2 = in2.receive();
        if (Circuit.debug){
            System.out.println(label+": "+i1+"+"+i2);
        }
        out.send(new Integer(i1.intValue()+i2.intValue()));
    }
}
